<script lang="ts">
import Vue from 'vue';

export default Vue.extend({
  props: {
    links: {
      required: true,
      type: Array,
    },
    position: {
      type: String,
      required: false,
      default: 'left',
    },
    variant: {
      type: String,
      required: false,
      default: '',
    },
    darkMode: {
      type: Boolean,
      required: false,
    },
    cta: {
      type: Object,
      required: false,
      default: null,
    },
  },
  data() {
    return {
      currentLinkIndex: 0,
      isDarkMode: this.darkMode,
    };
  },
  mounted() {
    // The height of an absolutely positioned container must be set for the sticky property to work
    const { sideNavParent } = this.$refs;
    this.$refs.sideNavigation.setAttribute(
      'style',
      `height: ${sideNavParent.clientHeight}px`,
    );
    const bottomObserverMargin = (window.innerHeight - 120 - 48) * -1;

    window.addEventListener('load', () => {
      const children = Array.from(sideNavParent.children).slice(1);
      const observer = new IntersectionObserver(
        (entries) => {
          entries.forEach((entry) => {
            if (entry.isIntersecting) {
              this.currentLinkIndex = children.findIndex(
                (item) => item === entry.target,
              );
              this.isDarkMode = entry.target.dataset.slippersScrollDarkmode;
            }
          });
        },
        {
          rootMargin: `-120px 0px ${bottomObserverMargin}px 0px`,
        },
      );
      children.forEach((section) => observer.observe(section));
    });
  },
});
</script>

<template>
  <div ref="sideNavParent">
    <div ref="sideNavigation" class="side-navigation" :class="position">
      <ul
        id="side-navigation__wrapper"
        class="side-navigation__wrapper"
        :class="{
          secondary: variant === 'secondary',
        }"
      >
        <li
          v-for="(link, index) in links"
          :key="link.title"
          class="slp-py-8 slp-my-8"
        >
          <SlpTypography
            class="side-navigation__text slp-pb-4"
            :class="{
              'side-navigation__text--hover': index === currentLinkIndex,
              'side-navigation__text--dark': isDarkMode,
            }"
            :variant="variant === 'secondary' ? 'body2' : 'all-caps'"
            tag="a"
            :href="link.href"
          >
            {{ link.title }}
          </SlpTypography>
          <span
            v-if="variant === 'secondary'"
            class="line"
            :class="{
              hover: index === currentLinkIndex,
            }"
          />
        </li>
        <SlpButton
          v-if="cta"
          :href="cta.href"
          class="cta"
          :class="{
            secondary: variant === 'secondary',
            dark: isDarkMode,
          }"
        >
          <SlpTypography variant="body3-bold">{{ cta.text }}</SlpTypography>
          <SlpIcon
            v-if="cta.icon"
            class="cta__icon"
            :name="cta.icon.name"
            variant="marketing"
            alt="Docs Icon"
            size="sm"
            :hex-color="(isDarkMode && cta.icon.color) || cta.icon.color_dark"
          />
        </SlpButton>
      </ul>
    </div>
    <slot></slot>
  </div>
</template>

<style lang="scss" scoped>
.side-navigation {
  position: absolute;
  z-index: 10;

  @media (min-width: 2200px) {
    margin-left: 22%;
  }
  @media (min-width: 1700px) {
    padding-left: 5%;
  }

  .secondary {
    margin-left: 0;
    li {
      display: flex;
      align-items: center;
      justify-content: flex-end;
    }
    .line {
      display: block;
      width: 32px;
      height: 1px;
      background: #7759c2;
      transition: all 0.25s ease;

      &.hover {
        width: 48px;
      }
    }
    .side-navigation__text {
      opacity: 1;
      color: $color-text-link-100;
      font-weight: 400;
      text-align: right;
      margin-right: 12px;

      &--dark {
        color: $color-accent-400 !important;
        opacity: 1;
        &.side-navigation__text--hover {
          color: $color-surface-800 !important;
        }
      }
      &--hover {
        box-shadow: none;
        margin-left: -$spacing-32;
        color: $color-text-300 !important;
      }
    }
  }

  .cta {
    margin-right: $spacing-16;
    &__icon {
      margin-left: $spacing-8;
    }
    &.secondary {
      border: 1px solid transparent;
      border-radius: 4px;
      color: black;
      background: linear-gradient(90deg, #f9f7ff 0%, #f9f7ff 100%) padding-box,
        linear-gradient(90deg, #ffeff1 0%, #cbb2ff 100%) border-box;
      transition: all 0.3s;
      &:hover {
        color: black;
        background: linear-gradient(90deg, white 0%, white 100%) padding-box,
          linear-gradient(90deg, #ffeff1 0%, #cbb2ff 100%) border-box;
      }

      &.secondary.dark {
        border: 1px solid transparent;
        border-radius: 4px;
        color: $color-surface-900;
        background: linear-gradient(90deg, black 0%, black 100%) padding-box,
          linear-gradient(90deg, #ffeff1 0%, #cbb2ff 100%) border-box;
        transition: all 0.3s;
        &:hover {
          color: black;
          background: linear-gradient(90deg, white 0%, white 100%) padding-box,
            linear-gradient(90deg, #ffeff1 0%, #cbb2ff 100%) border-box;
          .slp-icon {
            color: black !important;
          }
        }
      }
    }
  }

  &.right {
    right: 0;
  }

  &__wrapper {
    position: sticky;
    margin-top: $spacing-96;
    padding-bottom: $spacing-24;
    width: 100%;
    padding-left: $spacing-32;
    overflow: hidden;
    display: none;
    top: 256px;

    @media (min-width: $breakpoint-lg) {
      display: block;
      margin-left: 4vw;
    }

    @media (min-width: $breakpoint-2xl) {
      margin-left: 100px;
    }
  }

  &__text {
    transition: all 0.25s ease;
    opacity: 0.2;
    font-weight: 700;
    line-height: 12px;
    text-decoration: none;
    color: hsl(257, 27%, 10%);

    &--dark {
      color: #fff;
    }

    &:hover {
      text-decoration: none;
      color: $color-text-300;
      opacity: 1;
    }

    &--hover {
      box-shadow: inset 0 -2px 0 0 #7759c2;
      opacity: 1;
    }
  }
}
</style>
